#procedure integrationde93()

* This file is part of aITALC
* Copyright (C) 2004 Alejandro Lorca <alejandro.lorca@desy.de>
*------------------------------------------------------------- 
** Procedure to integrate 4,3,2,1-point funct.
** with internal momenta decomposition, like LoopTools. 
** Begun on 01/11/02.

** The decomposition reads eqs (4.6) (4.8) of Denner93

** First of all, we check which propagators c`i' are in the loop.
** We assume they are ordered or from 1 to LOOPTYPENUMBER or from 
** LINE-LOOPTYPENUMBER+1 to LINE

#if `LEVEL' == loop
*do integration

#redefine myloopindex "0"
#do i=1,`LINE'
 #if `loopline{`i'}' == 1
** it belongs to a loop
  #redefine myloopindex "{`myloopindex'+1}"
  #redefine den`myloopindex' "c`i'"
  #redefine msq`myloopindex' "`imm{`i'}'"
**  #message[myloopindex = `myloopindex']
**  #message[Line `i' gets den`i'=`den{`myloopindex'}' and m`myloopindex'sq=`m{`myloopindex'}sq']
 #elseif `loopline{`i'}' == 0
** it is a bridge
 #else
  #message[integrationde93: Error in loopline`i' variable, neither 1 nor 0!]
 #endif

#enddo


********* 5 POINT FUNCTIONS *********
#if `LOOPTYPE' == e

id q(mu1?)*q(mu2?)*q(mu3?)*q(mu4?)/`den1'/`den2'/`den3'/`den4'/`den5'= (
 d_(mu1,mu2)*d_(mu3,mu4)+d_(mu1,mu3)*d_(mu2,mu4)+d_(mu1,mu4)*d_(mu2,mu3)*T4(5,0,0,0,0)
#do j=1,3
  #do k=1,3
                                  +(
 + d_(mu1,mu2)*k`j'(mu3)*k`k'(mu4) 
 + d_(mu2,mu3)*k`j'(mu1)*k`k'(mu4) 
 + d_(mu1,mu3)*k`j'(mu2)*k`k'(mu4)
 + d_(mu1,mu4)*k`j'(mu2)*k`k'(mu3) 
 + d_(mu2,mu4)*k`j'(mu1)*k`k'(mu3) 
 + d_(mu3,mu4)*k`j'(mu1)*k`k'(mu2) )*T2(5,0,0,`j',`k')
    #do l=1,3
      #do m=1,3
         + k`j'(mu1)*k`k'(mu2)*k`l'(mu3)*k`m'(mu4)*T4(5,`j',`k',`l',`m')
      #enddo
    #enddo
  #enddo
#enddo
                                   );

** the permutation of index (like d1122 and d2211) is yet not done but
** e1122=e2211 and so..


id q(mu1?)*q(mu2?)*q(mu3?)/`den1'/`den2'/`den3'/`den4'/`den5'= (
#do i1=1,4
 +    ( d_(mu2,mu3)*k`i1'(mu1) + d_(mu3,mu1)*k`i1'(mu2) + d_(mu1,mu2)*k`i1'(mu3) ) * T3(5,0,0,`i1')
 +                                            ( k`i1'(mu1)*k`i1'(mu2)*k`i1'(mu3) ) * T3(5,`i1',`i1',`i1')
 #do i2={`i1'+1},4
 +(k`i1'(mu1)*k`i1'(mu2)*k`i2'(mu3)+k`i1'(mu1)*k`i2'(mu2)*k`i1'(mu3)+k`i2'(mu1)*k`i1'(mu2)*k`i1'(mu3))*T3(5,`i1',`i1',`i2')
 +(k`i1'(mu1)*k`i2'(mu2)*k`i2'(mu3)+k`i2'(mu1)*k`i1'(mu2)*k`i2'(mu3)+k`i2'(mu1)*k`i2'(mu2)*k`i1'(mu3))*T3(5,`i1',`i2',`i2')
  #do i3={`i2'+1},4
 +(k`i1'(mu1)*k`i2'(mu2)*k`i3'(mu3)+k`i3'(mu1)*k`i1'(mu2)*k`i2'(mu3)+k`i2'(mu1)*k`i3'(mu2)*k`i1'(mu3))*T3(5,`i1',`i2',`i3')
  #enddo
 #enddo
#enddo
                                           );


id q(mu1?)*q(mu2?)/`den1'/`den2'/`den3'/`den4'/`den5'= (
                                + d_(mu1,mu2)     * T2(5,0,0)
#do i1=1,4
                                + k`i1'(mu1)*k`i1'(mu2) * T2(5,`i1',`i1')
 #do i2={`i1'+1},4
                                + (k`i1'(mu1)*k`i2'(mu2) + k`i2'(mu1)*k`i1'(mu2))* T2(5,`i1',`i2')
 #enddo
#enddo
              );

id q(mu1?)/`den1'/`den2'/`den3'/`den4'/`den5'= (
#do i1=1,4
                            + k`i1'(mu1) * T1(5,`i1')
#enddo
                           );

id 1/`den1'/`den2'/`den3'/`den4'/`den5'= T0(5) ;

.sort
L [ArgumentsT,`COUNTER']=loopnorma*Targ(k1s,k12s,k23s,k34s,k4s,k2s,k13s,k24s,k3s,k14s,`msq5',`msq1',`msq2',`msq3',`msq4');


********* 4 POINT FUNCTIONS *********
#elseif `LOOPTYPE' == d

id q(mu1?)*q(mu2?)*q(mu3?)*q(mu4?)/`den1'/`den2'/`den3'/`den4'= (
 d_(mu1,mu2)*d_(mu3,mu4)+d_(mu1,mu3)*d_(mu2,mu4)+d_(mu1,mu4)*d_(mu2,mu3)*T4(4,0,0,0,0)
#do j=1,3
  #do k=1,3
                                  +(
 + d_(mu1,mu2)*k`j'(mu3)*k`k'(mu4) 
 + d_(mu2,mu3)*k`j'(mu1)*k`k'(mu4) 
 + d_(mu1,mu3)*k`j'(mu2)*k`k'(mu4)
 + d_(mu1,mu4)*k`j'(mu2)*k`k'(mu3) 
 + d_(mu2,mu4)*k`j'(mu1)*k`k'(mu3) 
 + d_(mu3,mu4)*k`j'(mu1)*k`k'(mu2) )*T2(4,0,0,`j',`k')
    #do l=1,3
      #do m=1,3
         + k`j'(mu1)*k`k'(mu2)*k`l'(mu3)*k`m'(mu4)*T4(4,`j',`k',`l',`m')
      #enddo
    #enddo
  #enddo
#enddo
                                                          )
;

** the permutation of index (like d1122 and d2211) is yet not done but
** d1122=d2211 and so...


id q(mu1?)*q(mu2?)*q(mu3?)/`den1'/`den2'/`den3'/`den4'= (
 +    ( d_(mu2,mu3)*k1(mu1) + d_(mu3,mu1)*k1(mu2) + d_(mu1,mu2)*k1(mu3) ) * T3(4,0,0,1)
 +    ( d_(mu2,mu3)*k2(mu1) + d_(mu3,mu1)*k2(mu2) + d_(mu1,mu2)*k2(mu3) ) * T3(4,0,0,2)
 +    ( d_(mu2,mu3)*k3(mu1) + d_(mu3,mu1)*k3(mu2) + d_(mu1,mu2)*k3(mu3) ) * T3(4,0,0,3)
 +                                            ( k1(mu1)*k1(mu2)*k1(mu3) ) * T3(4,1,1,1)
 +                                            ( k2(mu1)*k2(mu2)*k2(mu3) ) * T3(4,2,2,2)
 +                                            ( k3(mu1)*k3(mu2)*k3(mu3) ) * T3(4,3,3,3)
 +(k1(mu1)*k1(mu2)*k2(mu3)+k1(mu1)*k2(mu2)*k1(mu3)+k2(mu1)*k1(mu2)*k1(mu3))*T3(4,1,1,2)
 +(k1(mu1)*k1(mu2)*k3(mu3)+k1(mu1)*k3(mu2)*k1(mu3)+k3(mu1)*k1(mu2)*k1(mu3))*T3(4,1,1,3)
 +(k1(mu1)*k2(mu2)*k2(mu3)+k2(mu1)*k1(mu2)*k2(mu3)+k2(mu1)*k2(mu2)*k1(mu3))*T3(4,1,2,2)
 +(k1(mu1)*k2(mu2)*k3(mu3)+k3(mu1)*k1(mu2)*k2(mu3)+k2(mu1)*k3(mu2)*k1(mu3))*T3(4,1,2,3)
 +(k1(mu1)*k3(mu2)*k3(mu3)+k3(mu1)*k1(mu2)*k3(mu3)+k3(mu1)*k3(mu2)*k1(mu3))*T3(4,1,3,3)
 +(k2(mu1)*k2(mu2)*k3(mu3)+k2(mu1)*k3(mu2)*k2(mu3)+k3(mu1)*k2(mu2)*k2(mu3))*T3(4,2,2,3)
 +(k2(mu1)*k3(mu2)*k3(mu3)+k3(mu1)*k2(mu2)*k3(mu3)+k3(mu1)*k3(mu2)*k2(mu3))*T3(4,2,3,3)
                                                  );


id q(mu1?)*q(mu2?)/`den1'/`den2'/`den3'/`den4'= (
                                + d_(mu1,mu2)     * T2(4,0,0)
                                + k1(mu1)*k1(mu2) * T2(4,1,1)
                                + k2(mu1)*k2(mu2) * T2(4,2,2)
                                + k3(mu1)*k3(mu2) * T2(4,3,3)
             + (k1(mu1)*k2(mu2) + k2(mu1)*k1(mu2))* T2(4,1,2)
             + (k1(mu1)*k3(mu2) + k3(mu1)*k1(mu2))* T2(4,1,3)
             + (k2(mu1)*k3(mu2) + k3(mu1)*k2(mu2))* T2(4,2,3)
                                          );

id q(mu1?)/`den1'/`den2'/`den3'/`den4'= (
                                + k1(mu1) * T1(4,1)
                                + k2(mu1) * T1(4,2)
                                + k3(mu1) * T1(4,3)
                                  );

id 1/`den1'/`den2'/`den3'/`den4'= T0(4) ;

.sort
L [ArgumentsT,`COUNTER']=loopnorma*Targ(k1s,k12s,k23s,k3s,k2s,k13s,`msq4',`msq1',`msq2',`msq3');


********* 3 POINT FUNCTIONS *********
#elseif `LOOPTYPE' == c

id q(mu1?)*q(mu2?)*q(mu3?)/`den1'/`den2'/`den3'= (
 +    ( d_(mu2,mu3)*k1(mu1) + d_(mu3,mu1)*k1(mu2) + d_(mu1,mu2)*k1(mu3) ) * T3(3,0,0,1)
 +    ( d_(mu2,mu3)*k2(mu1) + d_(mu3,mu1)*k2(mu2) + d_(mu1,mu2)*k2(mu3) ) * T3(3,0,0,2)
 +                                            ( k1(mu1)*k1(mu2)*k1(mu3) ) * T3(3,1,1,1)
 +                                            ( k2(mu1)*k2(mu2)*k2(mu3) ) * T3(3,2,2,2)
 +(k1(mu1)*k1(mu2)*k2(mu3)+k1(mu1)*k2(mu2)*k1(mu3)+k2(mu1)*k1(mu2)*k1(mu3))*T3(3,1,1,2)
 +(k1(mu1)*k2(mu2)*k2(mu3)+k2(mu1)*k1(mu2)*k2(mu3)+k2(mu1)*k2(mu2)*k1(mu3))*T3(3,1,2,2)
                                               );

id q(mu1?)*q(mu2?)/`den1'/`den2'/`den3'= (
                             + d_(mu1,mu2)     * T2(3,0,0)
                             + k1(mu1)*k1(mu2) * T2(3,1,1)
                             + k2(mu1)*k2(mu2) * T2(3,2,2)
          + (k1(mu1)*k2(mu2) + k2(mu1)*k1(mu2))* T2(3,1,2)
                                       );

** Here no controversial exists; c1,c2 and c3 are substituted in denominator by
** c1 and c2 in numerator. Only highest number than c3 may still be in denom.
id q(mu1?)/`den1'/`den2'/`den3'= (
                             + k1(mu1) * T1(3,1)
                             + k2(mu1) * T1(3,2)
                               );

id 1/`den1'/`den2'/`den3'=  T0(3) ;

.sort
L [ArgumentsT,`COUNTER']=loopnorma*Targ(k1s,k12s,k2s,`msq3',`msq1',`msq2');


********* 2 POINT FUNCTIONS *********
#elseif `LOOPTYPE' == b

id q(mu1?)*q(mu2?)/`den1'/`den2'= (
                          + d_(mu1,mu2)     * T2(2,0,0)
                          + k1(mu1)*k1(mu2) * T2(2,1,1)
                                    );

id q(mu1?)/`den1'/`den2'=  (
                              + k1(mu1) * T1(2,1)
                             );

id 1/`den1'/`den2'=  T0(2) ;

.sort
L [ArgumentsT,`COUNTER']=loopnorma*Targ(k1s,`msq2',`msq1');


********* 1 POINT FUNCTIONS *********
#elseif `LOOPTYPE' == a

id 1/`den1'= T0(1) ;

.sort
L [ArgumentsT,`COUNTER']=loopnorma*Targ(`msq1');

* id a0=A0(`msq1');
#elseif `LOOPTYPE' == none

* Nothing should be done at tree level

#else
#message  [integration: The "LOOPTYPE" variable is to high for me!, no integration]
exit
.end
#endif !Of `LOOPTYPE'

** And finally include the normalization factor missing on the definition T()=(2*pi)^4/(i_*pi^2)*Int()
id loopnorma=+i_/16/Pi^2;
.sort
hide [ArgumentsT,`COUNTER'];


#else
** do nothing
#endif


#endprocedure
*$Id: integrationde93.prc,v 1.8 2004/10/29 13:07:26 alorca Exp $
